//+------------------------------------------------------------------+
//|                                                     CloseAll.mq4 |
//| origginal from codersguru, this version from mladen              |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property show_inputs
#property strict

enum options
{
   opt_0, // Close all (instant and pending orders) (Default)
   opt_1, // Close all instant orders
   opt_2, // Close all pending orders
   opt_3, // Close by the magic number
   opt_4, // Close by comment
   opt_5, // Close orders in profit
   opt_6, // Close orders in loss
   opt_7  // Close not today orders
};
extern options option            = 0;
extern int     magic_number      =  0; // set it if you'll use closing option 3 - closing by magic number
extern string  comment_text      = ""; // set it if you'll use closing option 4 - closing by comment
extern bool    justCurrentSymbol = true;

bool dummyResult;
int start()
{

   if (!IsTradeAllowed()) 
   {
      Alert("Live trading not allowed \n","Enable live trading so that the script can close/delete orders");
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   int cnt = 0;
   switch (option)
   {
      case opt_0:
            for (cnt = OrdersTotal()-1 ; cnt >= 0 ; cnt--)
            {
               RefreshRates();
               dummyResult = OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
               if (justCurrentSymbol && OrderSymbol()!=_Symbol) continue;
                  if(OrderType()==OP_BUY)
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
                  if(OrderType()==OP_SELL) 
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
                  if(OrderType()>OP_SELL) //pending orders
                     dummyResult = OrderDelete(OrderTicket());
            }
         break;
      case opt_1:
            for (cnt = OrdersTotal()-1 ; cnt >= 0 ; cnt--)
            {
               RefreshRates();
               dummyResult = OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
               if (justCurrentSymbol && OrderSymbol()!=_Symbol) continue;
                  if(OrderType()==OP_BUY)
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
                  if(OrderType()==OP_SELL) 
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
            }
         break;
      case opt_2:
            for (cnt = OrdersTotal()-1 ; cnt >= 0 ; cnt--)
            {
               RefreshRates();
               dummyResult = OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
                  if(OrderType()>OP_SELL)
                     dummyResult = OrderDelete(OrderTicket());
            }
         break;
      case opt_3:
            for (cnt = OrdersTotal()-1 ; cnt >= 0 ; cnt--)
            {
               RefreshRates();
               dummyResult = OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
               if (justCurrentSymbol && OrderSymbol()!=_Symbol) continue;
               if (OrderMagicNumber() == magic_number)
               {
                  if(OrderType()==OP_BUY)
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
                  if(OrderType()==OP_SELL) 
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
                  if(OrderType()>OP_SELL)
                     dummyResult = OrderDelete(OrderTicket());
               }
            }         
         break;
      case opt_4:
            for (cnt = OrdersTotal()-1 ; cnt >= 0 ; cnt--)
            {
               RefreshRates();
               dummyResult = OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
               if (justCurrentSymbol && OrderSymbol()!=_Symbol) continue;
               if (OrderComment() == comment_text)
               {
                  if(OrderType()==OP_BUY)
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
                  if(OrderType()==OP_SELL) 
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
                  if(OrderType()>OP_SELL)
                     dummyResult = OrderDelete(OrderTicket());
               }
            }         
         break;
      case opt_5:
            for (cnt = OrdersTotal()-1 ; cnt >= 0 ; cnt--)
            {
               RefreshRates();
               dummyResult = OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
               if (justCurrentSymbol && OrderSymbol()!=_Symbol) continue;
               if (OrderProfit() > 0)
               {
                  if(OrderType()==OP_BUY)
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
                  if(OrderType()==OP_SELL) 
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
                  if(OrderType()>OP_SELL)
                     dummyResult = OrderDelete(OrderTicket());
               }
            }         
         break;
      case opt_6:
            for (cnt = OrdersTotal()-1 ; cnt >= 0 ; cnt--)
            {
               RefreshRates();
               dummyResult = OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
               if (justCurrentSymbol && OrderSymbol()!=_Symbol) continue;
               if (OrderProfit() < 0)
               {
                  if(OrderType()==OP_BUY)
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
                  if(OrderType()==OP_SELL) 
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
                  if(OrderType()>OP_SELL)
                     dummyResult = OrderDelete(OrderTicket());
               }
            }         
         break;
      case opt_7:
            for (cnt = OrdersTotal()-1 ; cnt >= 0 ; cnt--)
            {
               RefreshRates();
               dummyResult = OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
               if (justCurrentSymbol && OrderSymbol()!=_Symbol) continue;
               if (TimeDay(OrderOpenTime()) < TimeDay(CurTime()))
               {
                  if(OrderType()==OP_BUY)
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_BID),5,Violet);
                  if(OrderType()==OP_SELL) 
                     dummyResult = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),MODE_ASK),5,Violet);
                  if(OrderType()>OP_SELL)
                     dummyResult = OrderDelete(OrderTicket());
               }
            }         
         break;
   }
   return(0);
}